//+------------------------------------------------------------------+
//|                                                      HiLoBar.mq4 |
//|                                      Copyright  2009, primajaya |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, primajaya"
#property link      ""

//---- input parameters
extern bool       EcnBroker=false;
extern double     TP = 20;
extern double     SL = 20;
extern int        PipsAdd = 5;
extern double     Lot = 0.1;
extern int        BarToTest = 1;
extern bool       UseHighestLowest = false;

#define Magic 7777777
#define Slippage 3

int bartime = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double pipMultiplier =1; if (Digits==3 || Digits==5) pipMultiplier = 10;
   if (UseHighestLowest)
   {
      GlobalVariableSet("uplevel", High[iHighest(NULL,0,MODE_HIGH,BarToTest,1)] + PipsAdd*Point);
      GlobalVariableSet("dnlevel", Low[iLowest(NULL,0,MODE_LOW,BarToTest,1)] - PipsAdd*Point);
   }
   else
   {
      GlobalVariableSet("uplevel", High[BarToTest] + PipsAdd*Point);
      GlobalVariableSet("dnlevel", Low[BarToTest] - PipsAdd*Point);
   }      
   int tiket;
   
   if(OrdersTotal()<1 && bartime != Time[0])
   {
      if(Bid>=GlobalVariableGet("uplevel"))
      {
         double slb = 0; if (SL>0) slb = NormalizeDouble(Ask-SL*Point*pipMultiplier,Digits);
         double tpb = 0; if (TP>0) tpb = NormalizeDouble(Ask+TP*Point*pipMultiplier,Digits);
         if (EcnBroker)
         {
               tiket = OrderSend(Symbol(),OP_BUY,Lot,Ask,Slippage,0,0,"",Magic,0,Navy);
               if (tiket>-1)
                  OrderModify(tiket,OrderOpenPrice(),slb,tpb,0);
         }               
         else  tiket = OrderSend(Symbol(),OP_BUY,Lot,Ask,Slippage,slb,tpb,"",Magic,0,Navy);
         if(tiket>0) bartime = Time[0];
      }
      if(Bid<=GlobalVariableGet("dnlevel"))
      {
         double sls = 0; if (SL>0) sls = NormalizeDouble(Bid+SL*Point*pipMultiplier,Digits);
         double tps = 0; if (TP>0) tps = NormalizeDouble(Bid-TP*Point*pipMultiplier,Digits);
         if (EcnBroker)
         {
               tiket = OrderSend(Symbol(),OP_SELL,Lot,Bid,Slippage,0,0,"",Magic,0,Red);
               if (tiket>-1)
                  OrderModify(tiket,OrderOpenPrice(),sls,tps,0);
         }
         else  tiket = OrderSend(Symbol(),OP_SELL,Lot,Bid,Slippage,sls,tps,"",Magic,0,Red);
         if(tiket>0) bartime = Time[0];
      }
      return(0);
   }
   
   for (int y=OrdersTotal()-1;y>=0;y--)
   {
         OrderSelect(y,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            if(OrderType()==OP_BUY)
            { 
                if(Bid<=GlobalVariableGet("dnlevel")) OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,CLR_NONE);
            }
            
            if(OrderType()==OP_SELL)
            {  
                if(Bid>=GlobalVariableGet("uplevel")) OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,CLR_NONE);
            }   
         }
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+